// The array to put each player's StopWatch instance in.
MyStopWatch <- array( GetMaxPlayers(), null );

// Class Header
class StopWatch {

	// Properties
    	startTime   =   0;
    	stopTime    =   0;
    	running     =   false;
	announce    =   false;

	// Member Functions.
    	function start( player )
	{
		// Add the instance to our array.
		MyStopWatch[ player.ID ] = StopWatch();

		// Set our class properties.	
		this[ "MyStopWatch" ][ player.ID ].startTime  = time();
		this[ "MyStopWatch" ][ player.ID ].running    = true;
		this[ "MyStopWatch" ][ player.ID ].announce   = true;
    	}

    	function stop( player ) 
	{
		// Reset our class properties.
        	this[ "MyStopWatch" ][ player.ID ].stopTime    = time();
        	this[ "MyStopWatch" ][ player.ID ].running     = false;
		this[ "MyStopWatch" ][ player.ID ].announce    = false;
    	}

	// This function announces the elapsed time to the player.
	function AnnounceMe( player )
	{
		// Check we have a StopWatch instance in our array.
		if ( this[ "MyStopWatch" ][ player.ID ] != null )
		{
			// Ensure we should be announcing.
			if ( this[ "MyStopWatch" ][ player.ID ].announce )
			{
	    			::Announce( MyStopWatch[ player.ID ].getElapsedTime( player ), player, 5 );
			}
			else StopWatch.stop( player );
		}
	}

    	// Calculates elapsed time in seconds using time(), then using the date function 
	// from the squirrel system library convert the result to mm:ss
    	function getElapsedTime( player )
	{
        	local elapsed = 0;
			
		if ( this[ "MyStopWatch" ][ player.ID ].running )
		{
			elapsed = ( ( time() - startTime ) );
		}
		else elapsed = ( ( stopTime - startTime ) );

		return format( "%02d:%02d", date( elapsed ).min, date( elapsed ).sec );
   	 }
}