function OnRaceStart(player)
{
	// Establish the track the player is on.
	local checkpoint = FindTrack( player.Skin );

	// Establish the world the track is in.
	local TrackWorld = FindTrackWorld( checkpoint );

	// Set the player's world accordingly.
	player.World = TrackWorld;

     	// Teleport player to the starting grid.
     	player.Pos = this[checkpoint][ 0 ][ 0 ];

	// Create a marker at the first checkpoint.
	MyMarker[ player.ID ] = CreateMarker( player.UniqueWorld, this[checkpoint][ 1 ][ 0 ], 5, RGB(0, 0, 0), 1 );

	// Start the stopwatch
	StopWatch.start( player );
	MessagePlayer( " >> Stopwatch Started! ", player );
}

function OnRaceEnd(player)
{
	// Establish the track the player is on.
	local checkpoint = FindTrack( player.Skin );

	// Stop the stopwatch
	if ( MyStopWatch[ player.ID ] != null )
	{
		if ( MyStopWatch[ player.ID ].running )
		{
 			StopWatch.stop( player );
			MessagePlayer( " >> Stopwatch Stopped at " + MyStopWatch[ player.ID ].getElapsedTime( player ), player );
		}
	}

	// Send them to the track selection screen
	if ( player.IsSpawned )
	{
		player.Pos = Vector( 0, 0, 0 );
		player.Health = 0;
		player.Armour = 0;
	}

	// Destroy all markers for specified player.
	RemoveMarkers( player );

     	// Reset the players value in the 'MyLastCheckPoint' array.
     	MyLastCheckPoint[ player.ID ] = 0;
}
