function onPlayerJoin( player )
{
	// Welcome the player.
	MessagePlayer( "Welcome " + player.Name + " to the server!", player );

	// Some Server News:
	PrivMessage( player, " === Squirrel Racing v1.5 Basic === ");
	PrivMessage( player, " Status: [IIIIIIIII.] 97% complete ");
	PrivMessage( player, " Playable Tracks: " + Num_Tracks );	
	PrivMessage( player, " Available Commands: /commands ");

	// Disable server Death Messages
	SetDeathMessages( false );
}

function onPlayerPart( player, reason )
{
	// Trigger the race end event.
	OnRaceEnd(player);
}

function onPlayerChat( player, message )
{
	// Allow player's to have in-game chat.
	return 1;
}

function onPlayerKill( killer, player, reason, bodypart )
{
	OnRaceEnd(player);
}

function onPlayerTeamKill( player, killer, reason, bodypart )
{
	OnRaceEnd(player);
}

function onPlayerDeath( player, reason )
{
	OnRaceEnd(player);
}

function onPlayerRequestClass( player, ID, Team, Skin )
{
	// Announce the TrackName.
     	Announce("~h~" + FindTrack( Skin ), player, 8 );

	if ( !(player.Name in this) )
	{
		this[ player.Name ] <- MessagePlayer( "Please select your track!", player );
	}
}

function onPlayerRequestSpawn( player )
{
	return 1;
}

function onPlayerSpawn( player )
{
	if ( player.Name in this )
	{
		delete this[ player.Name ];
	}

	OnRaceStart(player);
}


function onPickupPickedUp( player, pickup )
{
	// First, let's make sure the player is in a vehicle.
	if ( player.Vehicle != null )
	{
		// Now, Decypher if the player is within a radius of 'X' from the checkpoint centre.
		local IsPlayerAtCheckpoint = IsPlayerAtCheckpoint(player);

		// Ensure we have the correct pickup model ( id 382 can only be picked up by vehicles )
		// and also check 'IsPlayerAtCheckpoint' has a return value.
		if ( ( pickup.Model == 382 ) && ( IsPlayerAtCheckpoint ) )
		{
			// Grab the arrayname.
			local checkpoint = FindTrack( player.Skin );

			// Filter checkpoint independent Messages ( based on the return value of our 'IsPlayerAtCheckpoint' function )
			switch ( IsPlayerAtCheckpoint )
			{
				// Player is at the Last checkpoint.
				case this[checkpoint].len() - 1:

				// Announce the stopwatch
				StopWatch.AnnounceMe( player );

				// Call the OnRaceEnd event.
				OnRaceEnd(player);
				break;

				case -1:
				Announce( "Missed Checkpoint", player, 4 );
				break;

				default:

				// Announce the stopwatch
				StopWatch.AnnounceMe( player );

				// Display information in-game
				MessagePlayer( " Checkpoint: " + IsPlayerAtCheckpoint + "/" + ( this[checkpoint].len() - 1 ), player );
				break;
			}
		}
	}
}

function onPlayerCommand( player, cmd, text )
{
	// Establish the track.
	local checkpoint = FindTrack( player.Skin );

	if ( cmd == "info" ) 
	{
		Message( "Squirrel Racing v1.5 Basic - By Rulk" );
	}
	else if ( cmd == "commands" )
	{	
		MessagePlayer(" >> Available commands: '/'  info, igiveup, newcar, lastcp", player );
	}
	else if ( cmd == "igiveup" )
	{
		PrivMessage( player, "Winners never quit, and quitters never win!");
		OnRaceEnd(player);
	}
	else if ( cmd == "newcar" )
	{
		PrivMessage( player, "Spawning your new vehicle..." );
		CreateVehicle( 145, player.World, player.Pos, player.Angle, 1, 1 );
	}
	else if ( cmd == "lastcp" )
	{
		if ( ( player.IsSpawned ) && ( MyLastCheckPoint[ player.ID ] != 0 ) )
		{
			local veh = player.Vehicle;

			if ( !veh )
			{
				MessagePlayer( "Error: You are currently on foot.", player );
			}
          		else veh.Pos = this[checkpoint][ MyLastCheckPoint[ player.ID ] ][ 0 ];
		}
		else PrivMessage( player, "Please start a race first!" );
         }

	// Anything else is a unknown command.
	else PrivMessage( player, "I don't know that command!");
}