// Places all empty vehicles back to their original grid position.
function RestoreGrid()
{
	// calculate how many vehicles there should be. ( Num_Tracks * 8 vehicles per track )
	local MAX_VEHICLES = Num_Tracks*8;

	// Iterate the vehicles. ( the vcmp vehicle limit is 1000 )
    	for(local i = 0; i < 1000; i++)
    	{
		// if a vehicle instance is found
     		if ( FindVehicle( i ) ) 
		{
			// place it in a local variable so we
			// can use its properities.
			local vehicle    = FindVehicle( i ),
			      Currentpos = vehicle.Pos,
			      SpawnPos   = vehicle.SpawnPos;

			// check its not in use
			if ( vehicle.Driver == null )
			{	
				// expression must evaluate to true.
				switch( true )
				{
					// Any vehicle not at it's original position, put back.
					case ( (vehicle.ID < MAX_VEHICLES) && (!(vcompare(Currentpos, SpawnPos)))):
					vehicle.Respawn();
					break;

					case (vehicle.ID >= MAX_VEHICLES):
					vehicle.Delete();
					break;
				}
			}
		}
	}
}

// Removes all in-game markers for specified player.
function RemoveMarkers( player )
{
	DestroyMarker( MyMarker[ player.ID ] ); 
}

// compare vector elements.
function vcompare(v1, v2)
{
	local precision = 0.00001;

	if ( (((v1.x - precision) < v2.x) && ((v1.x + precision) > v2.x)) &&
	     (((v1.y - precision) < v2.y) && ((v1.y + precision) > v2.y)) ) return true; 	// They are equal
	else return false;
}